/**
 * Eine Warteschlange aus Piktogrammen.
 * Realisiert mit einer Liste von Knoten.
 * 
 * @author (your name) 
 * @version 2017-10-10
 */
public class Schlange
{
    private Knoten ersterKnoten;

    /**
     * Konstruktor.
     * Erzeuge eine leere Schlange.
     * Eine leere Schlange besitzt keinen ersten Knoten.
     */
    public Schlange ()
    {
        ersterKnoten = null;
    }

    /**
     * Nchster Kunde.
     * Nimm den vordersten Kunde aus der Schlange und rcke auf.
     * Gib den Kunden als Rckgabewert.
     * Falls die Schlange leer ist, gib null zurck.
     */
    public Person naechsterKunde ()
    {
        /*
         * Falls die Schlange leer ist ...
         */
        if (null == ersterKnoten)
        {
            /*
             * ... gib null zurck ...
             */
            return null;
        }
        /*
         * ... ansonsten ...
         */
        else
        {
            /*
             * ... gib die Person im ersten Knoten aus und lsche sie von
             * der Leinwand.
             */
            Person ausgabe = ersterKnoten.gibInhalt ();
            ausgabe.werdeUnsichtbar ();

            /*
             * Neuer erster Knoten ist der Nachfolger des bisherigen ersten
             * Knotens.
             */
            ersterKnoten = ersterKnoten.gibNachfolger ();

            /*
             * Verschiebe die ganze Schlange nach links.
             */
            verschiebeNachLinks ();

            return ausgabe;
        }
    }

    /**
     * Neuer Kunde.
     * Fge gem den Parametern einen neuen Kunden an die Schlange an.
     */
    public void neuerKunde (boolean weiblich, String name,
    String hautfarbe, String haarfarbe, String schuhfarbe,
    String kleiderfarbe1, String kleiderfarbe2, String kleiderfarbe3)
    {
        /*
         * Wenn die Schlange leer ist ...
         */
        if (null == ersterKnoten)
        {
            /*
             * ... kommt der neue Kunde an den Anfang der Schlange.
             */
            ersterKnoten = new Knoten (0, 100, weiblich, name, hautfarbe,
                haarfarbe, schuhfarbe, kleiderfarbe1, kleiderfarbe2,
                kleiderfarbe3);
        }
        /*
         * ... sonst (wenn die Schlange nicht leer ist) ...
         */
        else
        {
            /*
             * ... stelle den Kunden ganz hinten in die Schlange hinter dem
             * ersten Knoten an.
             */
            ersterKnoten.stelleHintenAn (1, weiblich, name, hautfarbe,
                haarfarbe, schuhfarbe, kleiderfarbe1, kleiderfarbe2,
                kleiderfarbe3);
        }
    }

    /**
     * Entferne.
     * Lsche den ersten Kunden mit dem Namen "name" aus der Schlange.
     * Falls kein Kunde dieses Namens ansteht, gib 0 zurck.
     */
    public Person loesche (String name)
    {
       /*
         * Falls die Schlange leer ist ...
         */
        if (null == ersterKnoten)
        {
            /*
             * ... melde zurck, dass keine Person mit dem angegebenen
             * Namen existiert.
             */
            return null;
        }
        /*
         * Falls aber die Person im ersten Knoten den angegebenen Name trgt, ...
         */
        else if (ersterKnoten.gibInhalt ().gibName ().equals (name))
        {
            /*
             * ,,, mache sie unsichtbar und lasse alle ihre Nachfolger an
             * ihren Platz aufrcken.
             */
            Person rueckgabe = ersterKnoten.gibInhalt ();
            rueckgabe.werdeUnsichtbar ();
            ersterKnoten.gibNachfolger ().verschiebeNachLinks ();           
            
            /*
             * Dann lsche die Person, indem du ihren Nachfolger zum neuen
             * erstenKnoten machst.
             */
            ersterKnoten = ersterKnoten.gibNachfolger ();
            
            /*
             * Gib den Inhalt des ursprnglichen ersten Knotens als gesuchte Person
             * zurck.
             */
            return rueckgabe;
            
        }
        /*
         * Andernfalls ...
         */
        {
            /*
             * ... lsche die erste Person mit dem angebenen Namen hinter dem
             * ersten Knoten.
             */
            return ersterKnoten.loescheHinterMir (name);
        }
    }

    /**
     * Lnge.
     * Nenne die Lnge der Schlange.
     */
    public int gibLaenge ()
    {
        if (null == ersterKnoten)
        {
            return 0;
        }
        else
        {
            return ersterKnoten.gibLaengeAbMir ();
        }
    }

    /**
     * Zufallskunden.
     * Fge n neue Zufallskunden an das Ende der Schlange an.
     */
    public void neueZufallskunden (int n)
    {
        boolean weiblich;
        String name;
        String hautfarbe;
        String haarfarbe;
        String schuhfarbe;
        String kleiderfarbe1;
        String kleiderfarbe2;
        String kleiderfarbe3;

        int zufall;

        for (int i = 1; i <= n; i++)
        {
            zufall = (int) Math.floor (2 * Math.random ());

            switch (zufall)
            {
                case 0:  weiblich = false; break;
                default: weiblich = true; break;
            }

            zufall = (int) Math.floor (10 * Math.random ());

            if (weiblich)
            {
                switch (zufall)
                {
                    case 0:  name = "Mia"; break;
                    case 1:  name = "Emma"; break;
                    case 2:  name = "Sophia"; break;
                    case 3:  name = "Hannah"; break;
                    case 4:  name = "Emilia"; break;
                    case 5:  name = "Anna"; break;
                    case 6:  name = "Marie"; break;
                    case 7:  name = "Mila"; break;
                    case 8:  name = "Lina"; break;
                    default: name = "Lea"; break;
                }
            }
            else
            {
                switch (zufall)
                {
                    case 0:  name = "Ben"; break;
                    case 1:  name = "Paul"; break;
                    case 2:  name = "Jonas"; break;
                    case 3:  name = "Elias"; break;
                    case 4:  name = "Leon"; break;
                    case 5:  name = "Finn"; break;
                    case 6:  name = "Noah"; break;
                    case 7:  name = "Louis"; break;
                    case 8:  name = "Lukas"; break;
                    default: name = "Felix"; break;
                }
            }

            zufall = (int) Math.floor (10 * Math.random ());

            switch (zufall)
            {
                case 0:  hautfarbe = "gebraeunt"; break;
                case 1:  hautfarbe = "hellbraun"; break;
                default: hautfarbe = "bleich"; break;
            }

            zufall = (int) Math.floor (10 * Math.random ());

            switch (zufall)
            {
                case 0:  haarfarbe = "rot"; break;
                case 1:
                case 2:
                case 3:  haarfarbe = "blond"; break;
                case 4:
                case 5:
                case 6:  haarfarbe = "braun"; break;
                default: haarfarbe = "schwarz"; break;
            }

            zufall = (int) Math.floor (10 * Math.random ());

            if (weiblich)
            {
                switch (zufall)
                {
                    case 0:
                    case 1:  kleiderfarbe1 = "rot"; break;
                    case 2:
                    case 3:  kleiderfarbe1 = "pink"; break;
                    case 4:
                    case 5:  kleiderfarbe1 = "lila"; break;
                    case 6:  kleiderfarbe1 = "gelb"; break;
                    case 7:  kleiderfarbe1 = "orange"; break;
                    case 8:  kleiderfarbe1 = "tuerkis"; break;
                    default: kleiderfarbe1 = "braun"; break;
                }
            }
            else
            {
                switch (zufall)
                {
                    case 0:
                    case 1: 
                    case 2:  kleiderfarbe1 = "grau"; break;
                    case 3: 
                    case 4:  kleiderfarbe1 = "braun"; break;
                    case 5:
                    case 6:  kleiderfarbe1 = "dunkelbraun"; break;
                    case 7: 
                    case 8:  kleiderfarbe1 = "schwarz"; break;
                    default: kleiderfarbe1 = "blau"; break;
                }
            }

            zufall = (int) Math.floor (10 * Math.random ());

            if (weiblich)
            {
                switch (zufall)
                {
                    case 0: 
                    case 1:  kleiderfarbe3 = "grau"; break;
                    case 2:
                    case 3:  kleiderfarbe3 = "hellbraun"; break;
                    case 4:
                    case 5:  kleiderfarbe3 = "schwarz"; break;
                    case 6:  kleiderfarbe3 = kleiderfarbe1; break;
                    default: kleiderfarbe3 = hautfarbe; break;
                }
            }
            else
            {
                switch (zufall)
                {
                    case 0:  kleiderfarbe3 = "grau"; break;
                    case 1:  kleiderfarbe3 = "braun"; break;
                    case 2:  kleiderfarbe3 = "dunkelbraun"; break;
                    case 3:  kleiderfarbe3 = "schwarz"; break;
                    case 4:
                    case 5:
                    case 6:  kleiderfarbe3 = "blau"; break;
                    default: kleiderfarbe3 = kleiderfarbe1;
                }
            }

            zufall = (int) Math.floor (10 * Math.random ());

            if (weiblich)
            {
                switch (zufall)
                {
                    case 0:  kleiderfarbe2 = "rot"; break;
                    case 1:  kleiderfarbe2 = "pink"; break;
                    case 2:  kleiderfarbe2 = "lila"; break;
                    case 3:  kleiderfarbe2 = "gelb"; break;
                    case 4:  kleiderfarbe2 = "tuerkis"; break;
                    default: kleiderfarbe2 = kleiderfarbe1; break;
                }
            }
            else
            {
                switch (zufall)
                {
                    case 0:  kleiderfarbe2 = "rot"; break;
                    case 1:  kleiderfarbe2 = "pink"; break;
                    case 2:  kleiderfarbe2 = "orange"; break;
                    case 3:  kleiderfarbe2 = "gruen"; break;
                    case 4:  kleiderfarbe2 = "tuerkis"; break;
                    case 5:  kleiderfarbe2 = "blau"; break;
                    case 6:  kleiderfarbe2 = "lila"; break;
                    case 7:  kleiderfarbe2 = "grau"; break;
                    case 8:  kleiderfarbe2 = "braun"; break;
                    default: kleiderfarbe2 = "schwarz"; break;
                }
            }

            zufall = (int) Math.floor (10 * Math.random ());

            if (weiblich)
            {
                switch (zufall)
                {
                    case 0:  schuhfarbe = "schwarz"; break;
                    case 1:  
                    case 2:  schuhfarbe = "hellbraun"; break;
                    case 3:  
                    case 4:  schuhfarbe = "dunkelbraun"; break;
                    case 5:
                    case 6:
                    case 7:  schuhfarbe = "braun"; break;
                    default: schuhfarbe = kleiderfarbe1; break;
                }
            }
            else
            {
                switch (zufall)
                {
                    case 0:
                    case 1:  schuhfarbe = "schwarz"; break;
                    case 2: 
                    case 3:  schuhfarbe = "hellbraun"; break;
                    case 4:
                    case 5:  schuhfarbe = "dunkelbraun"; break;
                    default: schuhfarbe = "braun"; break;
                }
            }

            neuerKunde (weiblich, name, hautfarbe, haarfarbe, schuhfarbe, 
                kleiderfarbe1, kleiderfarbe2, kleiderfarbe3);
        }
    }

    /**
     * Nenne die Anzahl der Frauen in der Warteschlange.
     */
    public int gibFrauenzahl ()
    {
        if (null == ersterKnoten)
        {
            return 0;
        }
        else
        {
            return ersterKnoten.gibFrauenzahl ();
        }
    }

    /**
     * Verschiebe die ganze Schlange nach links.
     */
    private void verschiebeNachLinks ()
    {
        if (null != ersterKnoten)
        {
            ersterKnoten.verschiebeNachLinks ();
        }
    }
}